package de.cliffbreak.varo.utils;

import java.util.Calendar;

import org.bukkit.entity.Player;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;
import org.bukkit.scoreboard.Team;

import de.cliffbreak.varo.Varo;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.ComponentBuilder;
import net.md_5.bungee.api.chat.HoverEvent;
import net.md_5.bungee.api.chat.TextComponent;

public class MessageUtils {

    private final Varo plugin;

    public MessageUtils(final Varo plugin) {
        this.plugin = plugin;
    }

    public TextComponent getServiceMessage(final String player, final String message) {
        final TextComponent component = new TextComponent(" ");
        component.addExtra(getTimeStamp());
        component.addExtra(getPlayerComponent(player));
        component.addExtra(new TextComponent(" §r§f" + message));
        return component;
    }

    public TextComponent getChatMessage(final String player, final String message) {
        final TextComponent component = new TextComponent(" ");
        component.addExtra(getTimeStamp());
        component.addExtra(getPlayerComponent(player));
        component.addExtra(new TextComponent(" §7>> §r§f" + message));
        return component;
    }

    private TextComponent getPlayerComponent(String player) {
        if (player.isEmpty()) {
            return new TextComponent();
        }
        final Team team = this.plugin.getTeamManager().getTeamByPlayer(player);
        final TextComponent component = new TextComponent(team.getPrefix().substring(2, 4) + player);
        component.setHoverEvent(new HoverEvent(HoverEvent.Action.SHOW_TEXT,
                new ComponentBuilder("§e" + "Name:" + "§r " + player + "\n§b" + "Team:" + "§r " + team.getDisplayName())
                        .create()));
        component.setClickEvent(new ClickEvent(ClickEvent.Action.SUGGEST_COMMAND, "/msg " + player + " "));
        return component;
    }

    private TextComponent getTimeStamp() {
        final Calendar calendar = Calendar.getInstance();
        final TextComponent component = new TextComponent(
                "§8" + String.format("%02d", calendar.get(Calendar.HOUR_OF_DAY)) + ":"
                        + String.format("%02d", calendar.get(Calendar.MINUTE)) + " §7| ");
        component.setHoverEvent(new HoverEvent(HoverEvent.Action.SHOW_TEXT,
                new ComponentBuilder("§7" + String.format("%02d", calendar.get(Calendar.HOUR_OF_DAY)) + ":"
                        + String.format("%02d", calendar.get(Calendar.MINUTE)) + ":"
                        + String.format("%02d", calendar.get(Calendar.SECOND))).create()));
        return component;
    }

    public String getDeathMessage(final Player victim, final Player killer, final DamageCause cause) {
        if (killer == null) {
            return this.plugin.getLangUtils().get("Death." + cause.toString()).replace("%player%", victim.getName());
        } else {
            return this.plugin.getLangUtils().get("Death." + cause.toString() + "killer")
                    .replace("%player%", victim.getName()).replace("%killer%", killer.getName());
        }
    }
}