package de.cliffbreak.varo.utils;

import com.destroystokyo.paper.Title;

import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.World.Environment;
import org.bukkit.entity.Player;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;

import de.cliffbreak.varo.Varo;

public class PlayerUtils {
    private final Varo plugin;

    public PlayerUtils(final Varo plugin) {
        this.plugin = plugin;
    }

    public void showLoadingScreen(final Player p, int seconds) {
        if (seconds < 10) {
            seconds = 10; // default to 10 seconds for a smooth transition
        }
        World w = null;
        for (final World world : Bukkit.getWorlds()) {
            if (world.getEnvironment().equals(Environment.THE_END)) {
                w = world;
            }
        }

        p.teleport(new Location(w, 0, 0, 100));
        p.setGameMode(GameMode.SPECTATOR);
        p.setFlying(true);
        p.setFlySpeed(0.0f);
        final Title title = new Title(this.plugin.getLangUtils().get("Service.LoadingTitle"),
                this.plugin.getLangUtils().get("Service.LoadingSubTitle"), 20, (seconds - 2) * 20, 20);
        p.sendTitle(title);

        p.addPotionEffect(new PotionEffect(PotionEffectType.BLINDNESS, seconds * 20, 1, false, false));

        final BukkitTask hidePlayersTask = new BukkitRunnable() {
            @Override
            public void run() {
                for (final Player player : Bukkit.getOnlinePlayers())
                    p.hidePlayer(plugin, player);
            }
        }.runTaskTimer(this.plugin, 0l, 1l);

        new BukkitRunnable() {
            @Override
            public void run() {
                final int seconds = plugin.getGameTimeManager().getLoginTimeLeft();
                if (seconds <= 0) {
                    this.cancel();
                    p.sendActionBar("");
                } else {
                    p.sendActionBar(String.format(plugin.getLangUtils().get("Service.LoadingCountdown"),
                            (int) Math.floor(seconds / 60), seconds % 60));
                }
            }
        }.runTaskTimer(this.plugin, 0, 20);

        new BukkitRunnable() {
            @Override
            public void run() {
                plugin.getNPCManager().removeClone(p);
                p.setGameMode(GameMode.SURVIVAL);
                p.setFlySpeed(0.1f);
                p.setFlying(false);
                p.teleport(plugin.getPlayerCache().getPlayerLocationCache(p.getUniqueId().toString().replace("-", "")));
                hidePlayersTask.cancel();
                for (final Player player : Bukkit.getOnlinePlayers())
                    p.showPlayer(plugin, player);
            }
        }.runTaskLater(this.plugin, seconds * 20);
    }

}